wxWidgets: wxPGProperty Class Reference

| Version: 3.2.6

Public Types | Public Member Functions | Public Attributes | Protected Member Functions | List of all members
wxPGProperty Class Reference
Class List by Category » wxPropertyGrid

`#include <wx/propgrid/property.h>`

Inheritance diagram for wxPGProperty:
[legend]

## Detailed Description

wxPGProperty is base class for all wxPropertyGrid properties and as such it is not intended to be instantiated directly.

In sections below we cover few related topics.

- Supplied Ready-to-use Property Classes
- Creating Custom Properties

# Supplied Ready-to-use Property Classes

Here is a list and short description of supplied fully-functional property classes. They are located in either props.h or advprops.h.

- wxArrayStringProperty
- wxBoolProperty
- wxColourProperty
- wxCursorProperty
- wxDateProperty
- wxDirProperty
- wxEditEnumProperty
- wxEnumProperty
- wxFileProperty
- wxFlagsProperty
- wxFloatProperty
- wxFontProperty
- wxImageFileProperty
- wxIntProperty
- wxLongStringProperty
- wxMultiChoiceProperty
- wxPropertyCategory
- wxStringProperty
- wxSystemColourProperty
- wxUIntProperty

## wxPropertyCategory

Not an actual property per se, but a header for a group of properties. Regardless inherits from wxPGProperty, and supports displaying 'labels' for columns other than the first one. Easiest way to set category's label for second column is to call wxPGProperty::SetValue() with string argument.

## wxStringProperty

Simple string property.

Supported special attributes:

- wxPG_STRING_PASSWORD: Set to true in order to echo value as asterisks and to use wxTE_PASSWORD on the editor (wxTextCtrl).
- wxPG_ATTR_AUTOCOMPLETE: Set to true to enable auto-completion (use a wxArrayString value), and is also supported by any property that happens to use a wxTextCtrl-based editor.
  See also
    wxPropertyGrid Property Attribute Identifiers
  Remarks
    wxStringProperty has a special trait: if it has value of "<composed>", and also has child properties, then its displayed value becomes composition of child property values, similar as with wxFontProperty, for instance.

## wxIntProperty

It derives from wxNumericProperty and displays value as a signed long integer. wxIntProperty seamlessly supports 64-bit integers (i.e. wxLongLong) on overflow. To safely convert variant to integer, use code like this:

wxLongLong ll;
ll << property->GetValue();
// or
wxLongLong ll = propertyGrid->GetPropertyValueAsLong(property);
wxLongLong
This class represents a signed 64 bit long number.
Definition: longlong.h:44
wxLongLong::GetValue
wxLongLong_t GetValue() const
Convert to native long long (only for compilers supporting it).

Getting 64-bit value:

wxLongLong_t value = pg->GetPropertyValueAsLongLong();
// or
wxLongLong value;
wxVariant variant = property->GetValue();
if ( variant.IsType(wxPG_VARIANT_TYPE_LONGLONG) )
value = variant.GetLongLong();
else
value = variant.GetLong();
wxVariant
The wxVariant class represents a container for any type.
Definition: variant.h:163
wxVariant::IsType
bool IsType(const wxString &type) const
Returns true if type matches the type of the variant, false otherwise.
wxVariant::GetLongLong
wxLongLong GetLongLong() const
Returns the signed 64-bit integer value.
wxVariant::GetLong
long GetLong() const
Returns the integer value.

Setting 64-bit value:

pg->SetPropertyValue(longLongVal);
// or
property->SetValue(WXVARIANT(longLongVal));

Supported special attributes:

- wxPG_ATTR_MIN, wxPG_ATTR_MAX to specify acceptable value range.
- wxPG_ATTR_SPINCTRL_STEP, wxPG_ATTR_SPINCTRL_WRAP, wxPG_ATTR_SPINCTRL_MOTION: Sets SpinCtrl editor parameters.
  See also
    wxPropertyGrid Property Attribute Identifiers

## wxUIntProperty

Like wxIntProperty, but displays value as unsigned int. To set the prefix used globally, manipulate wxPG_UINT_PREFIX string attribute. To set the globally used base, manipulate wxPG_UINT_BASE int attribute. Regardless of current prefix, understands (hex) values starting with both "0x" and "$" (apart from edit mode). Like wxIntProperty, wxUIntProperty seamlessly supports 64-bit unsigned integers (i.e. wxULongLong). Same wxVariant safety rules apply.

Supported special attributes:

- wxPG_ATTR_MIN, wxPG_ATTR_MAX: Specifies acceptable value range.
- wxPG_UINT_BASE: Defines base. Valid constants are wxPG_BASE_OCT, wxPG_BASE_DEC, wxPG_BASE_HEX and wxPG_BASE_HEXL (lowercase characters). Arbitrary bases are not supported.
- wxPG_UINT_PREFIX: Defines displayed prefix. Possible values are wxPG_PREFIX_NONE, wxPG_PREFIX_0x and wxPG_PREFIX_DOLLAR_SIGN. Only wxPG_PREFIX_NONE works with decimal and octal numbers.
- wxPG_ATTR_SPINCTRL_STEP, wxPG_ATTR_SPINCTRL_WRAP, wxPG_ATTR_SPINCTRL_MOTION: Sets SpinCtrl editor parameters.
  See also
    wxPropertyGrid Property Attribute Identifiers
  Remarks
    For example how to use seamless 64-bit integer support, see wxIntProperty documentation (just use wxULongLong instead of wxLongLong).

## wxFloatProperty

Like wxStringProperty, but converts text to a double-precision floating point. Default float-to-text precision is 6 decimals, but this can be changed by modifying wxPG_FLOAT_PRECISION attribute.

Note that when displaying the value, sign is omitted if the resulting textual representation is effectively zero (for example, -0.0001 with precision of 3 will become 0.0 instead of -0.0). This behaviour is unlike what C standard library does, but should result in better end-user experience in almost all cases.

Supported special attributes:

- wxPG_ATTR_MIN, wxPG_ATTR_MAX: Specifies acceptable value range.
- wxPG_FLOAT_PRECISION: Sets the (max) precision used when floating point value is rendered as text. The default -1 means shortest floating-point 6-digit representation.
- wxPG_ATTR_SPINCTRL_STEP, wxPG_ATTR_SPINCTRL_WRAP, wxPG_ATTR_SPINCTRL_MOTION: Sets SpinCtrl editor parameters.
  See also
    wxPropertyGrid Property Attribute Identifiers

## wxBoolProperty

Represents a boolean value. wxChoice is used as editor control, by the default. wxPG_BOOL_USE_CHECKBOX attribute can be set to true in order to use check box instead.

Supported special attributes:

- wxPG_BOOL_USE_CHECKBOX: If set to true uses check box editor instead of combo box.
- wxPG_BOOL_USE_DOUBLE_CLICK_CYCLING: If set to true cycles combo box instead showing the list.
  See also
    wxPropertyGrid Property Attribute Identifiers

## wxLongStringProperty

Like wxStringProperty, but has a button that triggers a small text editor dialog. Note that in long string values, some control characters are escaped: tab is represented by "\t", line break by "\n", carriage return by "\r" and backslash character by "\\". If another character is preceded by backslash, the backslash is skipped. Note also that depending on the system (port), some sequences of special characters, like e.g. "\r\n", can be interpreted and presented in a different way in the editor and therefore such sequences may not be the same before and after the edition.

To display a custom dialog on button press, you can subclass wxLongStringProperty and override DisplayEditorDialog, like this:

bool DisplayEditorDialog( wxPropertyGrid* propGrid, wxVariant& value ) wxOVERRIDE
{
wxSize dialogSize(...size of your dialog...);
wxPoint dlgPos = propGrid->GetGoodEditorDialogPosition(this,
dialogSize)
// Create dialog dlg at dlgPos. Use value as initial string
// value.
...
if ( dlg.ShowModal() == wxID_OK )
{
value = dlg.GetStringValue);
return true;
}
return false;
}
wxPoint
A wxPoint is a useful data structure for graphics operations.
Definition: gdicmn.h:659
wxPropertyGrid
wxPropertyGrid is a specialized grid for editing properties - in other words name = value pairs.
Definition: propgrid.h:487
wxSize
A wxSize is a useful data structure for graphics operations.
Definition: gdicmn.h:940
wxID_OK
@ wxID_OK
Standard button and menu IDs.
Definition: defs.h:664
wxOVERRIDE
#define wxOVERRIDE
wxOVERRIDE expands to the C++11 override keyword if it's supported by the compiler or nothing otherwi...
Definition: defs.h:1831

Also, if you wish not to have line breaks and tabs translated to escape sequences, then do following in constructor of your subclass:

m_flags |= wxPG_PROP_NO_ESCAPE;

Supported special attributes:

- wxPG_DIALOG_TITLE: Sets a specific title for the text editor dialog.

## wxDirProperty

Like wxLongStringProperty, but the button triggers dir selector instead.

Supported special attributes:

- wxPG_DIALOG_TITLE: Sets specific title for the dir selector.
  See also
    wxPropertyGrid Property Attribute Identifiers

## wxFileProperty

Like wxLongStringProperty, but the button triggers file selector instead. Default wildcard is "All files..." but this can be changed by setting wxPG_FILE_WILDCARD attribute.

Supported special attributes:

- wxPG_DIALOG_TITLE: Sets a specific title for the file dialog.
- wxPG_FILE_DIALOG_STYLE: Sets a specific wxFileDialog style for the file dialog.
- wxPG_FILE_WILDCARD: Sets wildcard (see wxFileDialog for format details), "All files..." is default.
- wxPG_FILE_SHOW_FULL_PATH: Default true. When false, only the file name is shown (i.e. drive and directory are hidden).
- wxPG_FILE_SHOW_RELATIVE_PATH: If set, then the filename is shown relative to the given path string.
- wxPG_FILE_INITIAL_PATH: Sets the initial path of where to look for files.
  See also
    wxPropertyGrid Property Attribute Identifiers

## wxEnumProperty

Represents a single selection from a list of choices - wxOwnerDrawnComboBox is used to edit the value.

## wxFlagsProperty

Represents a bit set that fits in a long integer. wxBoolProperty sub- properties are created for editing individual bits. Textctrl is created to manually edit the flags as a text; a continuous sequence of spaces, commas and semicolons are considered as a flag id separator.

Note: When changing "choices" (i.e. flag labels) of wxFlagsProperty, you will need to use wxPGProperty::SetChoices() - otherwise they will not get updated properly.

wxFlagsProperty supports the same attributes as wxBoolProperty.

## wxArrayStringProperty

Property that manages a list of strings. Allows editing of a list of strings in wxTextCtrl and in a separate dialog.

Supported special attributes:

- wxPG_ARRAY_DELIMITER: Sets string delimiter character.
- wxPG_DIALOG_TITLE: Sets a specific title for the editor dialog. Default is comma (',').
  See also
    wxPropertyGrid Property Attribute Identifiers

## wxDateProperty

Property representing wxDateTime. Default editor is DatePickerCtrl, although TextCtrl should work as well.

Supported special attributes:

- wxPG_DATE_FORMAT: Determines displayed date format (with wxDateTime::Format). Default is recommended as it is locale-dependent.
- wxPG_DATE_PICKER_STYLE: Determines window style used with wxDatePickerCtrl. Default is wxDP_DEFAULT | wxDP_SHOWCENTURY. Using wxDP_ALLOWNONE enables additional support for unspecified property value.
  See also
    wxPropertyGrid Property Attribute Identifiers

## wxEditEnumProperty

Represents a string that can be freely edited or selected from list of choices - custom combobox control is used to edit the value.

Remarks
  Uses int value, similar to wxEnumProperty, unless text entered by user is is not in choices (in which case string value is used).

## wxMultiChoiceProperty

Allows editing a multiple selection from a list of strings. This is property is pretty much built around concept of wxMultiChoiceDialog. It uses wxArrayString value.

Supported special attributes:

- wxPG_ATTR_MULTICHOICE_USERSTRINGMODE: If > 0, allows user to manually enter strings that are not in the list of choices. If this value is 1, user strings are preferably placed in front of valid choices. If value is 2, then those strings will placed behind valid choices.
- wxPG_DIALOG_TITLE: Sets a specific title for the editor dialog.
  See also
    wxPropertyGrid Property Attribute Identifiers

## wxImageFileProperty

Property representing image file(name). Like wxFileProperty, but has thumbnail of the image in front of the filename and autogenerates wildcard from available image handlers.

Supported special attributes:

- wxPG_DIALOG_TITLE: Sets a specific title for the file dialog.
- wxPG_FILE_DIALOG_STYLE: Sets a specific wxFileDialog style for the file dialog.
- wxPG_FILE_WILDCARD: Sets wildcard (see wxFileDialog for format details), "All files..." is default.
- wxPG_FILE_SHOW_FULL_PATH: Default true. When false, only the file name is shown (i.e. drive and directory are hidden).
- wxPG_FILE_SHOW_RELATIVE_PATH: If set, then the filename is shown relative to the given path string.
- wxPG_FILE_INITIAL_PATH: Sets the initial path of where to look for files.
  See also
    wxPropertyGrid Property Attribute Identifiers

## wxColourProperty

Useful alternate editor: Choice.

Represents wxColour. wxButton is used to trigger a colour picker dialog. There are various sub-classing opportunities with this class. See below in wxSystemColourProperty section for details.

Supported special attributes:

- wxPG_COLOUR_HAS_ALPHA: If set to true allows user to edit the alpha colour component.
  See also
    wxPropertyGrid Property Attribute Identifiers

## wxFontProperty

Represents wxFont. Various sub-properties are used to edit individual subvalues.

Supported special attributes:

- wxPG_DIALOG_TITLE: Sets a specific title for the font dialog.

## wxSystemColourProperty

Represents wxColour and a system colour index. wxChoice is used to edit the value. Drop-down list has color images. Note that value type is wxColourPropertyValue instead of wxColour (which wxColourProperty uses).

class wxColourPropertyValue : public wxObject
{
public:
// An integer value relating to the colour, and which exact
// meaning depends on the property with which it is used.
//
// For wxSystemColourProperty:
// Any of wxSYS_COLOUR_XXX, or any web-colour ( use wxPG_TO_WEB_COLOUR
// macro - (currently unsupported) ), or wxPG_COLOUR_CUSTOM.
wxUint32 m_type;
// Resulting colour. Should be correct regardless of type.
wxColour m_colour;
};
wxColour
A colour is an object representing a combination of Red, Green, and Blue (RGB) intensity values and a...
Definition: colour.h:69
wxColourPropertyValue
Because text, background and other colours tend to differ between platforms, wxSystemColourProperty m...
Definition: advprops.h:27
wxObject
This is the root class of many of the wxWidgets classes.
Definition: object.h:233
wxUint32
unsigned int wxUint32
32 bit type (the mapping is more complex than a simple typedef and is not shown here).
Definition: defs.h:1406

In wxSystemColourProperty, and its derived class wxColourProperty, there are various sub-classing features. To set a basic list of colour names, call wxPGProperty::SetChoices().

// Override in derived class to customize how colours are translated
// to strings.
virtual wxString ColourToString( const wxColour& col, int index ) const;
// Returns index of entry that triggers colour picker dialog
// (default is last).
virtual int GetCustomColourIndex() const;
// Helper function to show the colour dialog
bool QueryColourFromUser( wxVariant& variant ) const;
// Returns colour for given choice.
// Default function returns wxSystemSettings::GetColour(index).
virtual wxColour GetColour( int index ) const;
wxString
String class for passing textual data to or receiving it from wxWidgets.
Definition: string.h:315

## wxCursorProperty

Represents a wxCursor. wxChoice is used to edit the value. Drop-down list has cursor images under some (wxMSW) platforms.

# Creating Custom Properties

New properties can be created by subclassing wxPGProperty or one of the provided property classes, and (re)implementing necessary member functions. Below, each virtual member function has ample documentation about its purpose and any odd details which to keep in mind.

Here is a very simple 'template' code:

class MyProperty : public wxPGProperty
{
public:
// Default constructor
MyProperty() { }
// All arguments of this ctor must have a default value -
// use wxPG_LABEL for label and name
MyProperty( const wxString& label = wxPG_LABEL,
const wxString& name = wxPG_LABEL,
const wxString& value = wxEmptyString )
: wxPGProperty(label, name)
{
// m_value is wxVariant
m_value = value;
}
virtual ~MyProperty() { }
const wxPGEditor* DoGetEditorClass() const
{
// Determines editor used by property.
// You can replace 'TextCtrl' below with any of these
// builtin-in property editor identifiers: Choice, ComboBox,
// TextCtrlAndButton, ChoiceAndButton, CheckBox, SpinCtrl,
// DatePickerCtrl.
return wxPGEditor_TextCtrl;
}
virtual wxString ValueToString( wxVariant& value,
int argFlags ) const
{
// TODO: Convert given property value to a string
}
virtual bool StringToValue( wxVariant& variant, const wxString& text, int argFlags )
{
// TODO: Adapt string to property value.
}
protected:
};
wxPGEditor
Base class for custom wxPropertyGrid editors.
Definition: editors.h:61
wxPGProperty
wxPGProperty is base class for all wxPropertyGrid properties and as such it is not intended to be ins...
Definition: property.h:882
wxPGProperty::DoGetEditorClass
virtual const wxPGEditor * DoGetEditorClass() const
Returns pointer to an instance of used editor.
wxPGProperty::ValueToString
virtual wxString ValueToString(wxVariant &value, int argFlags=0) const
Converts property value into a text representation.
wxPGProperty::StringToValue
virtual bool StringToValue(wxVariant &variant, const wxString &text, int argFlags=0) const
Converts text into wxVariant value appropriate for this property.
wxPGEditor_TextCtrl
wxPGEditor * wxPGEditor_TextCtrl
wxEmptyString
wxString wxEmptyString
The global wxString instance of an empty string.
Definition: string.h:1977
wxPG_LABEL
#define wxPG_LABEL
Used to tell wxPGProperty to use label as name as well.
Definition: propgriddefs.h:13

Since wxPGProperty derives from wxObject, you can use standard wxDECLARE_DYNAMIC_CLASS and wxIMPLEMENT_DYNAMIC_CLASS macros. From the above example they were omitted for sake of simplicity, and besides, they are only really needed if you need to use wxRTTI with your property class.

You can change the 'value type' of a property by simply assigning different type of variant with SetValue. It is mandatory to implement wxVariantData class for all data types used as property values. You can use macros declared in wxPropertyGrid headers. For instance:

// In header file:
// (If you need to have export declaration, use version of macros
// with _EXPORTED postfix)
WX_PG_DECLARE_VARIANT_DATA(MyDataClass)
// In sources file:
WX_PG_IMPLEMENT_VARIANT_DATA(MyDataClass)
// Or, if you don't have valid == operator:
WX_PG_IMPLEMENT_VARIANT_DATA_DUMMY_EQ(MyDataClass)

##

Library: wxPropertyGrid
Category: wxPropertyGrid

## Public Types
typedef wxUint32 | FlagType

## Public Member Functions
virtual | ~wxPGProperty ()
| Virtual destructor. More...
virtual void | OnSetValue ()
| This virtual function is called after m_value has been set. More...
virtual wxVariant | DoGetValue () const
| Override this to return something else than m_value as the value. More...
virtual bool | ValidateValue (wxVariant &value, wxPGValidationInfo &validationInfo) const
| Implement this function in derived class to check the value. More...
virtual bool | StringToValue (wxVariant &variant, const wxString &text, int argFlags=0) const
| Converts text into wxVariant value appropriate for this property. More...
virtual bool | IntToValue (wxVariant &variant, int number, int argFlags=0) const
| Converts integer (possibly a choice selection) into wxVariant value appropriate for this property. More...
virtual wxString | ValueToString (wxVariant &value, int argFlags=0) const
| Converts property value into a text representation. More...
bool | SetValueFromString (const wxString &text, int flags=wxPG_PROGRAMMATIC_VALUE)
| Converts string to a value, and if successful, calls SetValue() on it. More...
bool | SetValueFromInt (long value, int flags=0)
| Converts integer to a value, and if successful, calls SetValue() on it. More...
virtual wxSize | OnMeasureImage (int item=-1) const
| Returns size of the custom painted image in front of property. More...
virtual bool | OnEvent (wxPropertyGrid *propgrid, wxWindow *wnd_primary, wxEvent &event)
| Events received by editor widgets are processed here. More...
virtual wxVariant | ChildChanged (wxVariant &thisValue, int childIndex, wxVariant &childValue) const
| Called after value of a child property has been altered. More...
virtual const wxPGEditor * | DoGetEditorClass () const
| Returns pointer to an instance of used editor. More...
virtual wxValidator * | DoGetValidator () const
| Returns pointer to the wxValidator that should be used with the editor of this property (NULL for no validator). More...
virtual void | OnCustomPaint (wxDC &dc, const wxRect &rect, wxPGPaintData &paintdata)
| Override to paint an image in front of the property value text or drop-down list item (but only if wxPGProperty::OnMeasureImage is overridden as well). More...
virtual wxPGCellRenderer * | GetCellRenderer (int column) const
| Returns used wxPGCellRenderer instance for given property column (label=0, value=1). More...
virtual int | GetChoiceSelection () const
| Returns which choice is currently selected. More...
virtual void | RefreshChildren ()
| Refresh values of child properties. More...
virtual bool | DoSetAttribute (const wxString &name, wxVariant &value)
| Reimplement this member function to add special handling for attributes of this property. More...
virtual wxVariant | DoGetAttribute (const wxString &name) const
| Returns value of an attribute. More...
virtual wxPGEditorDialogAdapter * | GetEditorDialog () const
| Returns instance of a new wxPGEditorDialogAdapter instance, which is used when user presses the (optional) button next to the editor control;. More...
virtual void | OnValidationFailure (wxVariant &pendingValue)
| Called whenever validation has failed with given pending value. More...
int | AddChoice (const wxString &label, int value=wxPG_INVALID_VALUE)
| Append a new choice to property's list of choices. More...
void | AddChild (wxPGProperty *prop)
| Adds a private child property. More...
void | AddPrivateChild (wxPGProperty *prop)
| Adds a private child property. More...
void | AdaptListToValue (wxVariant &list, wxVariant *value) const
| Adapts list variant into proper value using consecutive ChildChanged() calls. More...
wxPGProperty * | AppendChild (wxPGProperty *childProperty)
| Use this member function to add independent (i.e. More...
bool | AreAllChildrenSpecified (const wxVariant *pendingList=NULL) const
| Determines, recursively, if all children are not unspecified. More...
bool | AreChildrenComponents () const
| Returns true if children of this property are component values (for instance, points size, face name, and is_underlined are component values of a font). More...
void | ChangeFlag (wxPGPropertyFlags flag, bool set)
| Sets or clears given property flag. More...
void | DeleteChildren ()
| Deletes children of the property. More...
void | DeleteChoice (int index)
| Removes entry from property's wxPGChoices and editor control (if it is active). More...
void | Enable (bool enable=true)
| Enables or disables the property. More...
void | EnableCommonValue (bool enable=true)
| Call to enable or disable usage of common value (integer value that can be selected for properties instead of their normal values) for this property. More...
wxString | GenerateComposedValue () const
| Composes text from values of child properties. More...
const wxString & | GetLabel () const
| Returns property's label. More...
wxVariant | GetAttribute (const wxString &name) const
| Returns property attribute value, null variant if not found. More...
wxString | GetAttribute (const wxString &name, const wxString &defVal) const
| Returns named attribute, as string, if found. More...
long | GetAttributeAsLong (const wxString &name, long defVal) const
| Returns named attribute, as long, if found. More...
double | GetAttributeAsDouble (const wxString &name, double defVal) const
| Returns named attribute, as double, if found. More...
const wxPGAttributeStorage & | GetAttributes () const
| Returns map-like storage of property's attributes. More...
wxVariant | GetAttributesAsList () const
| Returns attributes as list wxVariant. More...
const wxPGEditor * | GetColumnEditor (int column) const
| Returns editor used for given column. More...
const wxString & | GetBaseName () const
| Returns property's base name (i.e. More...
const wxPGCell & | GetCell (unsigned int column) const
| Returns wxPGCell of given column. More...
wxPGCell & | GetCell (unsigned int column)
| Returns wxPGCell of given column, creating one if necessary. More...
wxPGCell & | GetOrCreateCell (unsigned int column)
| Returns wxPGCell of given column, creating one if necessary. More...
unsigned int | GetChildCount () const
| Returns number of child properties. More...
int | GetChildrenHeight (int lh, int iMax=-1) const
| Returns height of children, recursively, and by taking expanded/collapsed status into account. More...
const wxPGChoices & | GetChoices () const
| Returns read-only reference to property's list of choices. More...
void * | GetClientData () const
| Returns client data (void*) of a property. More...
wxClientData * | GetClientObject () const
| Gets managed client object of a property. More...
wxVariant | GetDefaultValue () const
| Returns property's default value. More...
int | GetCommonValue () const
| Returns common value selected for this property. More...
unsigned int | GetDepth () const
int | GetDisplayedCommonValueCount () const
| Return number of displayed common values for this property. More...
wxString | GetDisplayedString () const
| Returns property's displayed text. More...
const wxPGEditor * | GetEditorClass () const
| Returns wxPGEditor that will be used and created when property becomes selected. More...
wxString | GetHintText () const
| Returns property's hint text (shown in empty value cell). More...
wxPropertyGrid * | GetGrid () const
| Returns property grid where property lies. More...
wxPropertyGrid * | GetGridIfDisplayed () const
| Returns owner wxPropertyGrid, but only if one is currently on a page displaying this property. More...
const wxString & | GetHelpString () const
| Returns property's help or description text. More...
wxString | GetFlagsAsString (FlagType flagsMask) const
| Gets flags as a'|' delimited string. More...
unsigned int | GetIndexInParent () const
| Returns position in parent's array. More...
const wxPGProperty * | GetLastVisibleSubItem () const
| Returns last visible child property, recursively. More...
wxPGProperty * | GetMainParent () const
| Returns highest level non-category, non-root parent. More...
int | GetMaxLength () const
| Returns maximum allowed length of the text the user can enter in the property text editor. More...
wxString | GetName () const
| Returns property's name with all (non-category, non-root) parents. More...
wxPGProperty * | GetParent () const
| Return parent of property. More...
wxPGProperty * | GetPropertyByName (const wxString &name) const
| Returns (direct) child property with given name (or NULL if not found). More...
wxValidator * | GetValidator () const
| Gets assignable version of property's validator. More...
wxVariant | GetValue () const
| Returns property's value. More...
wxBitmap * | GetValueImage () const
| Returns bitmap that appears next to value text. More...
virtual wxString | GetValueAsString (int argFlags=0) const
| Returns text representation of property's value. More...
wxString | GetValueString (int argFlags=0) const
| Synonymous to GetValueAsString(). More...
wxString | GetValueType () const
| Returns value type used by this property. More...
int | GetY () const
| Returns coordinate to the top y of the property. More...
int | GetImageOffset (int imageWidth) const
| Converts image width into full image offset, with margins. More...
wxPGProperty * | GetItemAtY (unsigned int y) const
| Returns property at given virtual y coordinate. More...
bool | HasFlag (wxPGPropertyFlags flag) const
| Returns true if property has given flag set. More...
bool | HasFlag (FlagType flag) const
| Returns true if property has given flag set. More...
bool | HasFlagsExact (FlagType flags) const
| Returns true if property has all given flags set. More...
bool | HasVisibleChildren () const
| Returns true if property has even one visible child. More...
bool | Hide (bool hide, int flags=wxPG_RECURSE)
| Hides or reveals the property. More...
int | Index (const wxPGProperty *p) const
| Returns index of given child property. More...
wxPGProperty * | InsertChild (int index, wxPGProperty *childProperty)
| Use this member function to add independent (i.e. More...
int | InsertChoice (const wxString &label, int index, int value=wxPG_INVALID_VALUE)
| Inserts a new choice to property's list of choices. More...
bool | IsCategory () const
| Returns true if this property is actually a wxPropertyCategory. More...
bool | IsEnabled () const
| Returns true if property is enabled. More...
bool | IsExpanded () const
| Returns true if property has visible children. More...
bool | IsRoot () const
| Returns true if this property is actually a wxRootProperty. More...
bool | IsSubProperty () const
| Returns true if this is a sub-property. More...
bool | IsSomeParent (wxPGProperty *candidateParent) const
| Returns true if candidateParent is some parent of this property. More...
bool | IsTextEditable () const
| Returns true if property has editable wxTextCtrl when selected. More...
bool | IsValueUnspecified () const
| Returns true if property's value is considered unspecified. More...
bool | IsVisible () const
| Returns true if all parents expanded. More...
wxPGProperty * | Item (unsigned int i) const
| Returns child property at index i. More...
wxPGProperty * | Last () const
| Returns last sub-property. More...
bool | RecreateEditor ()
| If property's editor is created this forces its recreation. More...
void | RefreshEditor ()
| If property's editor is active, then update it's value. More...
void | SetAttribute (const wxString &name, wxVariant value)
| Sets an attribute for this property. More...
void | SetAttributes (const wxPGAttributeStorage &attributes)
void | SetAutoUnspecified (bool enable=true)
| Set if user can change the property's value to unspecified by modifying the value of the editor control (usually by clearing it). More...
void | SetBackgroundColour (const wxColour &colour, int flags=wxPG_RECURSE)
| Sets property's background colour. More...
void | SetEditor (const wxPGEditor *editor)
| Sets editor for a property. More...
void | SetEditor (const wxString &editorName)
| Sets editor for a property, by editor name. More...
void | SetCell (int column, const wxPGCell &cell)
| Sets cell information for given column. More...
void | SetCommonValue (int commonValue)
| Sets common value selected for this property. More...
bool | SetChoices (wxPGChoices &choices)
| Sets new set of choices for the property. More...
void | SetClientData (void *clientData)
| Sets client data (void*) of a property. More...
void | SetClientObject (wxClientData *clientObject)
| Sets client object of a property. More...
void | SetChoiceSelection (int newValue)
| Sets selected choice and changes property value. More...
void | SetDefaultValue (wxVariant &value)
| Set default value of a property. More...
void | SetExpanded (bool expanded)
void | SetFlagsFromString (const wxString &str)
| Sets flags from a '|' delimited string. More...
void | SetFlagRecursively (wxPGPropertyFlags flag, bool set)
| Sets or clears given property flag, recursively. More...
void | SetHelpString (const wxString &helpString)
| Sets property's help string, which is shown, for example, in wxPropertyGridManager's description text box. More...
void | SetLabel (const wxString &label)
| Sets property's label. More...
bool | SetMaxLength (int maxLen)
| Set maximum length of the text the user can enter in the text editor. More...
void | SetModifiedStatus (bool modified)
| Sets property's "is it modified?" flag. More...
void | SetName (const wxString &newName)
| Sets new (base) name for property. More...
void | SetParentalType (int flag)
| Changes what sort of parent this property is for its children. More...
void | SetTextColour (const wxColour &colour, int flags=wxPG_RECURSE)
| Sets property's text colour. More...
void | SetDefaultColours (int flags=wxPG_RECURSE)
| Sets property's default text and background colours. More...
void | SetValidator (const wxValidator &validator)
| Sets wxValidator for a property. More...
void | SetValue (wxVariant value, wxVariant *pList=NULL, int flags=wxPG_SETVAL_REFRESH_EDITOR)
| Call this to set value of the property. More...
void | SetValueImage (wxBitmapBundle &bmp)
| Set wxBitmap taken from wxBitmapBundle in front of the value. More...
void | SetValueInEvent (const wxVariant &value) const
| Call this function in OnEvent(), OnButtonClick() etc. More...
void | SetValueToUnspecified ()
| Sets property's value to unspecified (i.e. More...
void | SetWasModified (bool set=true)
| Call with false in OnSetValue() to cancel value changes after all (i.e. More...
wxPGProperty * | UpdateParentValues ()
| Updates composed values of parent non-category properties, recursively. More...
bool | UsesAutoUnspecified () const
| Returns true if containing grid uses wxPG_EX_AUTO_UNSPECIFIED_VALUES. More...
Public Member Functions inherited from wxObject
| wxObject ()
| Default ctor; initializes to NULL the internal reference data. More...
| wxObject (const wxObject &other)
| Copy ctor. More...
virtual | ~wxObject ()
| Destructor. More...
virtual wxClassInfo * | GetClassInfo () const
| This virtual function is redefined for every class that requires run-time type information, when using the wxDECLARE_CLASS macro (or similar). More...
wxObjectRefData * | GetRefData () const
| Returns the wxObject::m_refData pointer, i.e. the data referenced by this object. More...
bool | IsKindOf (const wxClassInfo *info) const
| Determines whether this class is a subclass of (or the same class as) the given class. More...
bool | IsSameAs (const wxObject &obj) const
| Returns true if this object has the same data pointer as obj. More...
void | Ref (const wxObject &clone)
| Makes this object refer to the data in clone. More...
void | SetRefData (wxObjectRefData *data)
| Sets the wxObject::m_refData pointer. More...
void | UnRef ()
| Decrements the reference count in the associated data, and if it is zero, deletes the data. More...
void | UnShare ()
| This is the same of AllocExclusive() but this method is public. More...
void | operator delete (void *buf)
| The delete operator is defined for debugging versions of the library only, when the identifier `__WXDEBUG__` is defined. More...
void * | operator new (size_t size, const wxString &filename=NULL, int lineNum=0)
| The new operator is defined for debugging versions of the library only, when the identifier `__WXDEBUG__` is defined. More...

## Public Attributes
void * | m_clientData
| This member is public so scripting language bindings wrapper code can access it freely. More...

## Protected Member Functions
| wxPGProperty ()
| Default constructor. More...
| wxPGProperty (const wxString &label, const wxString &name)
| Constructor. More...
void | AdaptiveSetCell (unsigned int firstCol, unsigned int lastCol, const wxPGCell &preparedCell, const wxPGCell &srcData, wxPGCellData *unmodCellData, FlagType ignoreWithFlags, bool recursively)
| Sets property cell in fashion that reduces number of exclusive copies of cell data. More...
void | ClearCells (FlagType ignoreWithFlags, bool recursively)
| Clear cells associated with property. More...
void | EnsureCells (unsigned int column)
| Makes sure m_cells has size of column+1 (or more). More...
wxPGProperty * | GetPropertyByNameWH (const wxString &name, unsigned int hintIndex) const
| Returns (direct) child property with given name (or NULL if not found), with hint index. More...
void | DoAddChild (wxPGProperty *prop, int index=-1, bool correct_mode=true)
| This is used by Insert etc. More...
void | Empty ()
| Deletes all child properties. More...
bool | IsChildSelected (bool recursive=false) const
| Returns true if child property is selected. More...
Protected Member Functions inherited from wxObject
void | AllocExclusive ()
| Ensure that this object's data is not shared with any other object. More...
virtual wxObjectRefData * | CreateRefData () const
| Creates a new instance of the wxObjectRefData-derived class specific to this object and returns it. More...
virtual wxObjectRefData * | CloneRefData (const wxObjectRefData *data) const
| Creates a new instance of the wxObjectRefData-derived class specific to this object and initializes it copying data. More...

## Additional Inherited Members
Protected Attributes inherited from wxObject
wxObjectRefData * | m_refData
| Pointer to an object which is the object's reference-counted data. More...

## Member Typedef Documentation

## ◆ FlagType

typedef wxUint32 wxPGProperty::FlagType

## Constructor & Destructor Documentation

## ◆ ~wxPGProperty()

virtual wxPGProperty::~wxPGProperty | ( |  | ) |
| virtual

Virtual destructor.

It is customary for derived properties to implement this.

## ◆ wxPGProperty() [1/2]

wxPGProperty::wxPGProperty | ( |  | ) |
| protected

Default constructor.

It is protected because wxPGProperty is only a base class for other property classes.

## ◆ wxPGProperty() [2/2]

wxPGProperty::wxPGProperty | ( | const wxString & | label,
|  | const wxString & | name
| ) |  |
| protected

Constructor.

It is protected because wxPGProperty is only a base class for other property classes. Non-abstract property classes should have constructor of this style:

MyProperty( const wxString& label, const wxString& name, const T& value )
: wxPGProperty(label, name)
{
// Generally recommended way to set the initial value
// (as it should work in pretty much 100% of cases).
wxVariant variant;
variant << value;
SetValue(variant);
// If has private child properties then create them here.
// For example:
// AddPrivateChild( new wxStringProperty("Subprop 1",
// wxPG_LABEL,
// value.GetSubProp1()));
}
wxPGProperty::SetValue
void SetValue(wxVariant value, wxVariant *pList=NULL, int flags=wxPG_SETVAL_REFRESH_EDITOR)
Call this to set value of the property.

## Member Function Documentation

## ◆ AdaptiveSetCell()

void wxPGProperty::AdaptiveSetCell | ( | unsigned int | firstCol,
|  | unsigned int | lastCol,
|  | const wxPGCell & | preparedCell,
|  | const wxPGCell & | srcData,
|  | wxPGCellData * | unmodCellData,
|  | FlagType | ignoreWithFlags,
|  | bool | recursively
| ) |  |
| protected

Sets property cell in fashion that reduces number of exclusive copies of cell data.

Used when setting, for instance, same background colour for a number of properties.

Parameters

  firstCol | First column to affect.
  lastCol | Last column to affect.
  preparedCell | Pre-prepared cell that is used for those which cell data before this matched unmodCellData.
  srcData | If unmodCellData did not match, valid cell data from this is merged into cell (usually generating new exclusive copy of cell's data).
  unmodCellData | If cell's cell data matches this, its cell is now set to preparedCell.
  ignoreWithFlags | Properties with any one of these flags are skipped.
  recursively | If true, apply this operation recursively in child properties.

## ◆ AdaptListToValue()

void wxPGProperty::AdaptListToValue | ( | wxVariant & | list,
|  | wxVariant * | value
| ) |  | const

Adapts list variant into proper value using consecutive ChildChanged() calls.

## ◆ AddChild()

void wxPGProperty::AddChild | ( | wxPGProperty * | prop | ) |

Adds a private child property.

Deprecated:
  Use AddPrivateChild() instead.

See also
  AddPrivateChild()

## ◆ AddChoice()

int wxPGProperty::AddChoice | ( | const wxString & | label,
|  | int | value = `wxPG_INVALID_VALUE`
| ) |  |

Append a new choice to property's list of choices.

Parameters

  label | Label for added choice.
  value | Value for new choice. Do not specify if you wish this to equal choice index.

Returns
  Index to added choice.

## ◆ AddPrivateChild()

void wxPGProperty::AddPrivateChild | ( | wxPGProperty * | prop | ) |

Adds a private child property.

If you use this instead of wxPropertyGridInterface::Insert() or wxPropertyGridInterface::AppendIn(), then property's parental type will automatically be set up to wxPG_PROP_AGGREGATE. In other words, all properties of this property will become private.

## ◆ AppendChild()

wxPGProperty* wxPGProperty::AppendChild | ( | wxPGProperty * | childProperty | ) |

Use this member function to add independent (i.e.

regular) children to a property.

Returns
  Appended childProperty.

Remarks
  wxPropertyGrid is not automatically refreshed by this function.

See also
  InsertChild(), AddPrivateChild()

## ◆ AreAllChildrenSpecified()

bool wxPGProperty::AreAllChildrenSpecified | ( | const wxVariant * | pendingList = `NULL` | ) | const

Determines, recursively, if all children are not unspecified.

Parameters

  pendingList | Assumes members in this wxVariant list as pending replacement values.

## ◆ AreChildrenComponents()

bool wxPGProperty::AreChildrenComponents | ( |  | ) | const

Returns true if children of this property are component values (for instance, points size, face name, and is_underlined are component values of a font).

## ◆ ChangeFlag()

void wxPGProperty::ChangeFlag | ( | wxPGPropertyFlags | flag,
|  | bool | set
| ) |  |

Sets or clears given property flag.

Mainly for internal use.

Remarks
  Setting a property flag never has any side-effect, and is intended almost exclusively for internal use. So, for example, if you want to disable a property, call
  Enable(false)
  wxPGProperty::Enable
  void Enable(bool enable=true)
  Enables or disables the property.
  instead of setting wxPG_PROP_DISABLED flag.

See also
  HasFlag(), GetFlags()

## ◆ ChildChanged()

virtual wxVariant wxPGProperty::ChildChanged | ( | wxVariant & | thisValue,
|  | int | childIndex,
|  | wxVariant & | childValue
| ) |  | const
| virtual

Called after value of a child property has been altered.

Must return new value of the whole property (after any alterations warranted by child's new value).

Note that this function is usually called at the time that value of this property, or given child property, is still pending for change, and as such, result of GetValue() or m_value should not be relied on.

Sample pseudo-code implementation:

wxVariant MyProperty::ChildChanged( wxVariant& thisValue,
int childIndex,
wxVariant& childValue ) const
{
// Acquire reference to actual type of data stored in variant
// (TFromVariant only exists if wxPropertyGrid's wxVariant-macros
// were used to create the variant class).
T& data = TFromVariant(thisValue);
// Copy childValue into data.
switch ( childIndex )
{
case 0:
data.SetSubProp1( childvalue.GetLong() );
break;
case 1:
data.SetSubProp2( childvalue.GetString() );
break;
...
}
// Return altered data
return data;
}

Parameters

  thisValue | Value of this property. Changed value should be returned (in previous versions of wxPropertyGrid it was only necessary to write value back to this argument).
  childIndex | Index of child changed (you can use Item(childIndex) to get child property).
  childValue | (Pending) value of the child property.

Returns
  Modified value of the whole property.

Reimplemented in wxFlagsProperty, and wxFontProperty.

## ◆ ClearCells()

void wxPGProperty::ClearCells | ( | FlagType | ignoreWithFlags,
|  | bool | recursively
| ) |  |
| protected

Clear cells associated with property.

Parameters

  ignoreWithFlags | Cells will not be cleared for properties having these flags set.
  recursively | If true, apply this operation recursively in child properties.

Since
  3.1.0

## ◆ DeleteChildren()

void wxPGProperty::DeleteChildren | ( |  | ) |

Deletes children of the property.

## ◆ DeleteChoice()

void wxPGProperty::DeleteChoice | ( | int | index | ) |

Removes entry from property's wxPGChoices and editor control (if it is active).

If selected item is deleted, then the value is set to unspecified.

## ◆ DoAddChild()

void wxPGProperty::DoAddChild | ( | wxPGProperty * | prop,
|  | int | index = `-1`,
|  | bool | correct_mode = `true`
| ) |  |
| protected

This is used by Insert etc.

## ◆ DoGetAttribute()

virtual wxVariant wxPGProperty::DoGetAttribute | ( | const wxString & | name | ) | const
| virtual

Returns value of an attribute.

Override if custom handling of attributes is needed.

Default implementation simply return NULL variant.

## ◆ DoGetEditorClass()

virtual const wxPGEditor* wxPGProperty::DoGetEditorClass | ( |  | ) | const
| virtual

Returns pointer to an instance of used editor.

## ◆ DoGetValidator()

virtual wxValidator* wxPGProperty::DoGetValidator | ( |  | ) | const
| virtual

Returns pointer to the wxValidator that should be used with the editor of this property (NULL for no validator).

Setting validator explicitly via SetPropertyValidator will override this.

In most situations, code like this should work well (macros are used to maintain one actual validator instance, so on the second call the function exits within the first macro):

wxValidator* wxMyPropertyClass::DoGetValidator () const
{
WX_PG_DOGETVALIDATOR_ENTRY()
wxMyValidator* validator = new wxMyValidator(...);
... prepare validator...
WX_PG_DOGETVALIDATOR_EXIT(validator)
}
wxValidator
wxValidator is the base class for a family of validator classes that mediate between a class of contr...
Definition: validate.h:38

Remarks
  You can get common filename validator by returning wxFileProperty::GetClassValidator(). wxDirProperty, for example, uses it.

Reimplemented in wxDirProperty, wxFileProperty, wxFloatProperty, wxUIntProperty, and wxIntProperty.

## ◆ DoGetValue()

virtual wxVariant wxPGProperty::DoGetValue | ( |  | ) | const
| virtual

Override this to return something else than m_value as the value.

## ◆ DoSetAttribute()

virtual bool wxPGProperty::DoSetAttribute | ( | const wxString & | name,
|  | wxVariant & | value
| ) |  |
| virtual

Reimplement this member function to add special handling for attributes of this property.

Returns
  Return false to have the attribute automatically stored in m_attributes. Default implementation simply does that and nothing else.

Remarks
  To actually set property attribute values from the application, use wxPGProperty::SetAttribute() instead.

Reimplemented in wxArrayStringProperty, wxFileProperty, wxEditorDialogProperty, wxFlagsProperty, wxBoolProperty, wxFloatProperty, wxUIntProperty, wxNumericProperty, wxStringProperty, wxDateProperty, and wxSystemColourProperty.

## ◆ Empty()

void wxPGProperty::Empty | ( |  | ) |
| protected

Deletes all child properties.

## ◆ Enable()

void wxPGProperty::Enable | ( | bool | enable = `true` | ) |

Enables or disables the property.

Disabled property usually appears as having grey text.

Parameters

  enable | If false, property is disabled instead.

See also
  wxPropertyGridInterface::EnableProperty()

## ◆ EnableCommonValue()

void wxPGProperty::EnableCommonValue | ( | bool | enable = `true` | ) |

Call to enable or disable usage of common value (integer value that can be selected for properties instead of their normal values) for this property.

Common values are disabled by the default for all properties.

## ◆ EnsureCells()

void wxPGProperty::EnsureCells | ( | unsigned int | column | ) |
| protected

Makes sure m_cells has size of column+1 (or more).

## ◆ GenerateComposedValue()

wxString wxPGProperty::GenerateComposedValue | ( |  | ) | const

Composes text from values of child properties.

## ◆ GetAttribute() [1/2]

wxVariant wxPGProperty::GetAttribute | ( | const wxString & | name | ) | const

Returns property attribute value, null variant if not found.

Remarks
  For built-in attribute returns null variant if extra style wxPG_EX_WRITEONLY_BUILTIN_ATTRIBUTES is set.

## ◆ GetAttribute() [2/2]

wxString wxPGProperty::GetAttribute | ( | const wxString & | name,
|  | const wxString & | defVal
| ) |  | const

Returns named attribute, as string, if found.

Otherwise defVal is returned.

Remarks
  For built-in attribute returns defVal if extra style wxPG_EX_WRITEONLY_BUILTIN_ATTRIBUTES is set.

## ◆ GetAttributeAsDouble()

double wxPGProperty::GetAttributeAsDouble | ( | const wxString & | name,
|  | double | defVal
| ) |  | const

Returns named attribute, as double, if found.

Otherwise defVal is returned.

Remarks
  For built-in attribute returns defVal if extra style wxPG_EX_WRITEONLY_BUILTIN_ATTRIBUTES is set.

## ◆ GetAttributeAsLong()

long wxPGProperty::GetAttributeAsLong | ( | const wxString & | name,
|  | long | defVal
| ) |  | const

Returns named attribute, as long, if found.

Otherwise defVal is returned.

Remarks
  For built-in attribute returns defVal if extra style wxPG_EX_WRITEONLY_BUILTIN_ATTRIBUTES is set.

## ◆ GetAttributes()

const wxPGAttributeStorage& wxPGProperty::GetAttributes | ( |  | ) | const

Returns map-like storage of property's attributes.

Remarks
  If extra style wxPG_EX_WRITEONLY_BUILTIN_ATTRIBUTES is set, then builtin-attributes are not included in the storage.

## ◆ GetAttributesAsList()

wxVariant wxPGProperty::GetAttributesAsList | ( |  | ) | const

Returns attributes as list wxVariant.

Remarks
  If extra style wxPG_EX_WRITEONLY_BUILTIN_ATTRIBUTES is set, then builtin-attributes are not included in the list.

## ◆ GetBaseName()

const wxString& wxPGProperty::GetBaseName | ( |  | ) | const

Returns property's base name (i.e.

parent's name is not added in any case).

## ◆ GetCell() [1/2]

wxPGCell& wxPGProperty::GetCell | ( | unsigned int | column | ) |

Returns wxPGCell of given column, creating one if necessary.

## ◆ GetCell() [2/2]

const wxPGCell& wxPGProperty::GetCell | ( | unsigned int | column | ) | const

Returns wxPGCell of given column.

Remarks
  const version of this member function returns 'default' wxPGCell object if the property itself didn't hold cell data.

## ◆ GetCellRenderer()

virtual wxPGCellRenderer* wxPGProperty::GetCellRenderer | ( | int | column | ) | const
| virtual

Returns used wxPGCellRenderer instance for given property column (label=0, value=1).

Default implementation returns editor's renderer for all columns.

## ◆ GetChildCount()

unsigned int wxPGProperty::GetChildCount | ( |  | ) | const

Returns number of child properties.

## ◆ GetChildrenHeight()

int wxPGProperty::GetChildrenHeight | ( | int | lh,
|  | int | iMax = `-1`
| ) |  | const

Returns height of children, recursively, and by taking expanded/collapsed status into account.

Parameters

  lh | Line height. Pass result of GetGrid()->GetRowHeight() here.
  iMax | Only used (internally) when finding property y-positions.

## ◆ GetChoices()

const wxPGChoices& wxPGProperty::GetChoices | ( |  | ) | const

Returns read-only reference to property's list of choices.

## ◆ GetChoiceSelection()

virtual int wxPGProperty::GetChoiceSelection | ( |  | ) | const
| virtual

Returns which choice is currently selected.

Only applies to properties which have choices.

Needs to reimplemented in derived class if property value does not map directly to a choice. Integer as index, bool, and string usually do.

Reimplemented in wxFlagsProperty, and wxEnumProperty.

## ◆ GetClientData()

void* wxPGProperty::GetClientData | ( |  | ) | const

Returns client data (void*) of a property.

## ◆ GetClientObject()

wxClientData* wxPGProperty::GetClientObject | ( |  | ) | const

Gets managed client object of a property.

## ◆ GetColumnEditor()

const wxPGEditor* wxPGProperty::GetColumnEditor | ( | int | column | ) | const

Returns editor used for given column.

NULL for no editor.

## ◆ GetCommonValue()

int wxPGProperty::GetCommonValue | ( |  | ) | const

Returns common value selected for this property.

-1 for none.

## ◆ GetDefaultValue()

wxVariant wxPGProperty::GetDefaultValue | ( |  | ) | const

Returns property's default value.

If property's value type is not a built-in one, and "DefaultValue" attribute is not defined, then this function usually returns Null variant.

## ◆ GetDepth()

unsigned int wxPGProperty::GetDepth | ( |  | ) | const

## ◆ GetDisplayedCommonValueCount()

int wxPGProperty::GetDisplayedCommonValueCount | ( |  | ) | const

Return number of displayed common values for this property.

## ◆ GetDisplayedString()

wxString wxPGProperty::GetDisplayedString | ( |  | ) | const

Returns property's displayed text.

## ◆ GetEditorClass()

const wxPGEditor* wxPGProperty::GetEditorClass | ( |  | ) | const

Returns wxPGEditor that will be used and created when property becomes selected.

Returns more accurate value than DoGetEditorClass().

## ◆ GetEditorDialog()

virtual wxPGEditorDialogAdapter* wxPGProperty::GetEditorDialog | ( |  | ) | const
| virtual

Returns instance of a new wxPGEditorDialogAdapter instance, which is used when user presses the (optional) button next to the editor control;.

Default implementation returns NULL (i.e. no action is generated when button is pressed).

Reimplemented in wxEditorDialogProperty.

## ◆ GetFlagsAsString()

wxString wxPGProperty::GetFlagsAsString | ( | FlagType | flagsMask | ) | const

Gets flags as a'|' delimited string.

Note that flag names are not prepended with 'wxPG_PROP_'.

Parameters

  flagsMask | String will only be made to include flags combined by this parameter.

## ◆ GetGrid()

wxPropertyGrid* wxPGProperty::GetGrid | ( |  | ) | const

Returns property grid where property lies.

## ◆ GetGridIfDisplayed()

wxPropertyGrid* wxPGProperty::GetGridIfDisplayed | ( |  | ) | const

Returns owner wxPropertyGrid, but only if one is currently on a page displaying this property.

## ◆ GetHelpString()

const wxString& wxPGProperty::GetHelpString | ( |  | ) | const

Returns property's help or description text.

See also
  SetHelpString()

## ◆ GetHintText()

wxString wxPGProperty::GetHintText | ( |  | ) | const
| inline

Returns property's hint text (shown in empty value cell).

## ◆ GetImageOffset()

int wxPGProperty::GetImageOffset | ( | int | imageWidth | ) | const

Converts image width into full image offset, with margins.

## ◆ GetIndexInParent()

unsigned int wxPGProperty::GetIndexInParent | ( |  | ) | const

Returns position in parent's array.

## ◆ GetItemAtY()

wxPGProperty* wxPGProperty::GetItemAtY | ( | unsigned int | y | ) | const

Returns property at given virtual y coordinate.

## ◆ GetLabel()

const wxString& wxPGProperty::GetLabel | ( |  | ) | const

Returns property's label.

## ◆ GetLastVisibleSubItem()

const wxPGProperty* wxPGProperty::GetLastVisibleSubItem | ( |  | ) | const

Returns last visible child property, recursively.

## ◆ GetMainParent()

wxPGProperty* wxPGProperty::GetMainParent | ( |  | ) | const

Returns highest level non-category, non-root parent.

Useful when you have nested properties with children.

Remarks
  If immediate parent is root or category, this will return the property itself.

## ◆ GetMaxLength()

int wxPGProperty::GetMaxLength | ( |  | ) | const

Returns maximum allowed length of the text the user can enter in the property text editor.

Remarks
  0 is returned if length is not explicitly limited and the text can be as long as it is supported by the underlying native text control widget.

## ◆ GetName()

wxString wxPGProperty::GetName | ( |  | ) | const

Returns property's name with all (non-category, non-root) parents.

## ◆ GetOrCreateCell()

wxPGCell& wxPGProperty::GetOrCreateCell | ( | unsigned int | column | ) |

Returns wxPGCell of given column, creating one if necessary.

## ◆ GetParent()

wxPGProperty* wxPGProperty::GetParent | ( |  | ) | const

Return parent of property.

## ◆ GetPropertyByName()

wxPGProperty* wxPGProperty::GetPropertyByName | ( | const wxString & | name | ) | const

Returns (direct) child property with given name (or NULL if not found).

Parameters

  name | Name of the child property to look for.

## ◆ GetPropertyByNameWH()

wxPGProperty* wxPGProperty::GetPropertyByNameWH | ( | const wxString & | name,
|  | unsigned int | hintIndex
| ) |  | const
| protected

Returns (direct) child property with given name (or NULL if not found), with hint index.

Parameters

  name | Name of the child property to look for.
  hintIndex | Start looking for the child at this index.

Remarks
  Does not support scope (i.e. Parent.Child notation).

## ◆ GetValidator()

wxValidator* wxPGProperty::GetValidator | ( |  | ) | const

Gets assignable version of property's validator.

## ◆ GetValue()

wxVariant wxPGProperty::GetValue | ( |  | ) | const

Returns property's value.

## ◆ GetValueAsString()

virtual wxString wxPGProperty::GetValueAsString | ( | int | argFlags = `0` | ) | const
| virtual

Returns text representation of property's value.

Parameters

  argFlags | If 0 (default value), then displayed string is returned. If wxPG_FULL_VALUE is set, returns complete, storable string value instead of displayable. If wxPG_EDITABLE_VALUE is set, returns string value that must be editable in textctrl. If wxPG_COMPOSITE_FRAGMENT is set, returns text that is appropriate to display as a part of string property's composite text representation.

Remarks
  In older versions, this function used to be overridden to convert property's value into a string representation. This function is now handled by ValueToString(), and overriding this function now will result in run-time assertion failure.

Reimplemented in wxPropertyCategory.

## ◆ GetValueImage()

wxBitmap* wxPGProperty::GetValueImage | ( |  | ) | const

Returns bitmap that appears next to value text.

Only returns non-NULL bitmap if one was set with SetValueImage().

## ◆ GetValueString()

wxString wxPGProperty::GetValueString | ( | int | argFlags = `0` | ) | const

Synonymous to GetValueAsString().

Deprecated:
  Use GetValueAsString() instead.

See also
  GetValueAsString()

## ◆ GetValueType()

wxString wxPGProperty::GetValueType | ( |  | ) | const

Returns value type used by this property.

## ◆ GetY()

int wxPGProperty::GetY | ( |  | ) | const

Returns coordinate to the top y of the property.

Note that the position of scrollbars is not taken into account.

## ◆ HasFlag() [1/2]

bool wxPGProperty::HasFlag | ( | FlagType | flag | ) | const

Returns true if property has given flag set.

## ◆ HasFlag() [2/2]

bool wxPGProperty::HasFlag | ( | wxPGPropertyFlags | flag | ) | const

Returns true if property has given flag set.

See also
  propgrid_propflags

## ◆ HasFlagsExact()

bool wxPGProperty::HasFlagsExact | ( | FlagType | flags | ) | const

Returns true if property has all given flags set.

## ◆ HasVisibleChildren()

bool wxPGProperty::HasVisibleChildren | ( |  | ) | const

Returns true if property has even one visible child.

## ◆ Hide()

bool wxPGProperty::Hide | ( | bool | hide,
|  | int | flags = `wxPG_RECURSE`
| ) |  |

Hides or reveals the property.

Parameters

  hide | true for hide, false for reveal.
  flags | By default changes are applied recursively. Set this parameter to wxPG_DONT_RECURSE to prevent this.

## ◆ Index()

int wxPGProperty::Index | ( | const wxPGProperty * | p | ) | const

Returns index of given child property.

wxNOT_FOUND if given property is not child of this.

## ◆ InsertChild()

wxPGProperty* wxPGProperty::InsertChild | ( | int | index,
|  | wxPGProperty * | childProperty
| ) |  |

Use this member function to add independent (i.e.

regular) children to a property.

Returns
  Inserted childProperty.

Remarks
  wxPropertyGrid is not automatically refreshed by this function.

See also
  AppendChild(), AddPrivateChild()

## ◆ InsertChoice()

int wxPGProperty::InsertChoice | ( | const wxString & | label,
|  | int | index,
|  | int | value = `wxPG_INVALID_VALUE`
| ) |  |

Inserts a new choice to property's list of choices.

Parameters

  label | Text for new choice
  index | Insertion position. Use wxNOT_FOUND to append.
  value | Value for new choice. Do not specify if you wish this to equal choice index.

## ◆ IntToValue()

virtual bool wxPGProperty::IntToValue | ( | wxVariant & | variant,
|  | int | number,
|  | int | argFlags = `0`
| ) |  | const
| virtual

Converts integer (possibly a choice selection) into wxVariant value appropriate for this property.

Parameters

  variant | On function entry this is the old value (should not be wxNullVariant in normal cases). Translated value must be assigned back to it.
  number | Integer to be translated into variant.
  argFlags | If wxPG_FULL_VALUE is set, returns complete, storable value instead of displayable one.

Returns
  Returns true if resulting wxVariant value was different.

Remarks
  - If property is not supposed to use choice or spinctrl or other editor with int-based value, it is not necessary to implement this method.
  - Default implementation simply assign given int to m_value.
  - If property uses choice control, and displays a dialog on some choice items, then it is preferred to display that dialog in IntToValue instead of OnEvent.
  - You might want to take into account that m_value is Mull variant if property value is unspecified (which is usually only case if you explicitly enabled that sort behaviour).

Reimplemented in wxEnumProperty, wxBoolProperty, wxUIntProperty, wxIntProperty, and wxSystemColourProperty.

## ◆ IsCategory()

bool wxPGProperty::IsCategory | ( |  | ) | const

Returns true if this property is actually a wxPropertyCategory.

## ◆ IsChildSelected()

bool wxPGProperty::IsChildSelected | ( | bool | recursive = `false` | ) | const
| protected

Returns true if child property is selected.

## ◆ IsEnabled()

bool wxPGProperty::IsEnabled | ( |  | ) | const

Returns true if property is enabled.

## ◆ IsExpanded()

bool wxPGProperty::IsExpanded | ( |  | ) | const

Returns true if property has visible children.

## ◆ IsRoot()

bool wxPGProperty::IsRoot | ( |  | ) | const

Returns true if this property is actually a wxRootProperty.

## ◆ IsSomeParent()

bool wxPGProperty::IsSomeParent | ( | wxPGProperty * | candidateParent | ) | const

Returns true if candidateParent is some parent of this property.

Use, for example, to detect if item is inside collapsed section.

## ◆ IsSubProperty()

bool wxPGProperty::IsSubProperty | ( |  | ) | const

Returns true if this is a sub-property.

## ◆ IsTextEditable()

bool wxPGProperty::IsTextEditable | ( |  | ) | const

Returns true if property has editable wxTextCtrl when selected.

Remarks
  Although disabled properties do not displayed editor, they still return true here as being disabled is considered a temporary condition (unlike being read-only or having limited editing enabled).

## ◆ IsValueUnspecified()

bool wxPGProperty::IsValueUnspecified | ( |  | ) | const

Returns true if property's value is considered unspecified.

This usually means that value is Null variant.

## ◆ IsVisible()

bool wxPGProperty::IsVisible | ( |  | ) | const

Returns true if all parents expanded.

## ◆ Item()

wxPGProperty* wxPGProperty::Item | ( | unsigned int | i | ) | const

Returns child property at index i.

## ◆ Last()

wxPGProperty* wxPGProperty::Last | ( |  | ) | const

Returns last sub-property.

## ◆ OnCustomPaint()

virtual void wxPGProperty::OnCustomPaint | ( | wxDC & | dc,
|  | const wxRect & | rect,
|  | wxPGPaintData & | paintdata
| ) |  |
| virtual

Override to paint an image in front of the property value text or drop-down list item (but only if wxPGProperty::OnMeasureImage is overridden as well).

If property's OnMeasureImage() returns size that has height != 0 but less than row height ( < 0 has special meanings), wxPropertyGrid calls this method to draw a custom image in a limited area in front of the editor control or value text/graphics, and if control has drop-down list, then the image is drawn there as well (even in the case OnMeasureImage() returned higher height than row height).

NOTE: Following applies when OnMeasureImage() returns a "flexible" height ( using `wxPG_FLEXIBLE_SIZE(W,H)` macro), which implies variable height items: If (rect.x+rect.width) is < 0, then this is a measure item call, which means that dc is invalid and only thing that should be done is to set paintdata.m_drawnHeight to the height of the image of item at index paintdata.m_choiceItem. This call may be done even as often as once every drop-down popup show.

Parameters

  dc | wxDC to paint on.
  rect | Box reserved for custom graphics. Includes surrounding rectangle, if any. If x+width is < 0, then this is a measure item call (see above).
  paintdata | wxPGPaintData structure with much useful data about painted item. struct wxPGPaintData { // wxPropertyGrid. const wxPropertyGrid* m_parent; // Normally -1, otherwise index to drop-down list item that has to be drawn. int m_choiceItem; // Set to drawn width in OnCustomPaint (optional). int m_drawnWidth; // In a measure item call, set this to the height of item at m_choiceItem index int m_drawnHeight; }; wxPGPaintData Contains information related to property's OnCustomPaint. Definition: property.h:16

Remarks
  - You can actually exceed rect width, but if you do so then paintdata.m_drawnWidth must be set to the full width drawn in pixels.
  - Due to technical reasons, rect's height will be default even if custom height was reported during measure call.
  - Brush is guaranteed to be default background colour. It has been already used to clear the background of area being painted. It can be modified.
  - Pen is guaranteed to be 1-wide 'black' (or whatever is the proper colour) pen for drawing framing rectangle. It can be changed as well.

See also
  ValueToString()

Reimplemented in wxImageFileProperty, wxCursorProperty, and wxSystemColourProperty.

## ◆ OnEvent()

virtual bool wxPGProperty::OnEvent | ( | wxPropertyGrid * | propgrid,
|  | wxWindow * | wnd_primary,
|  | wxEvent & | event
| ) |  |
| virtual

Events received by editor widgets are processed here.

Note that editor class usually processes most events. Some, such as button press events of TextCtrlAndButton class, can be handled here. Also, if custom handling for regular events is desired, then that can also be done (for example, wxSystemColourProperty custom handles `wxEVT_CHOICE` to display colour picker dialog when 'custom' selection is made).

If the event causes value to be changed, SetValueInEvent() should be called to set the new value.

The parameter event is the associated wxEvent.

Return values

  Should | return true if any changes in value should be reported.

Remarks
  - If property uses choice control, and displays a dialog on some choice items, then it is preferred to display that dialog in IntToValue instead of OnEvent.

Reimplemented in wxSystemColourProperty.

## ◆ OnMeasureImage()

virtual wxSize wxPGProperty::OnMeasureImage | ( | int | item = `-1` | ) | const
| virtual

Returns size of the custom painted image in front of property.

This method must be overridden to return non-default value if OnCustomPaint is to be called.

Parameters

  item | Normally -1, but can be an index to the property's list of items.

Remarks
  - Default behaviour is to return wxSize(0,0), which means no image.
  - Default image width or height is indicated with dimension -1.
  - You can also return wxPG_DEFAULT_IMAGE_SIZE which equals wxDefaultSize.

Reimplemented in wxImageFileProperty, wxCursorProperty, and wxSystemColourProperty.

## ◆ OnSetValue()

virtual void wxPGProperty::OnSetValue | ( |  | ) |
| virtual

This virtual function is called after m_value has been set.

Remarks
  - If m_value was set to Null variant (i.e. unspecified value), OnSetValue() will not be called.
  - m_value may be of any variant type. Typically properties internally support only one variant type, and as such OnSetValue() provides a good opportunity to convert supported values into internal type.
  - Default implementation does nothing.

Reimplemented in wxArrayStringProperty, wxFileProperty, wxFlagsProperty, wxEnumProperty, wxStringProperty, wxDateProperty, wxMultiChoiceProperty, wxImageFileProperty, wxSystemColourProperty, and wxFontProperty.

## ◆ OnValidationFailure()

virtual void wxPGProperty::OnValidationFailure | ( | wxVariant & | pendingValue | ) |
| virtual

Called whenever validation has failed with given pending value.

Remarks
  If you implement this in your custom property class, please remember to call the base implementation as well, since they may use it to revert property into pre-change state.

## ◆ RecreateEditor()

bool wxPGProperty::RecreateEditor | ( |  | ) |

If property's editor is created this forces its recreation.

Useful in SetAttribute etc. Returns true if actually did anything.

## ◆ RefreshChildren()

virtual void wxPGProperty::RefreshChildren | ( |  | ) |
| virtual

Refresh values of child properties.

Automatically called after value is set.

Reimplemented in wxFlagsProperty, and wxFontProperty.

## ◆ RefreshEditor()

void wxPGProperty::RefreshEditor | ( |  | ) |

If property's editor is active, then update it's value.

## ◆ SetAttribute()

void wxPGProperty::SetAttribute | ( | const wxString & | name,
|  | wxVariant | value
| ) |  |

Sets an attribute for this property.

Parameters

  name | Text identifier of attribute. See wxPropertyGrid Property Attribute Identifiers.
  value | Value of attribute.

Remarks
  Setting attribute's value to Null variant will simply remove it from property's set of attributes.

## ◆ SetAttributes()

void wxPGProperty::SetAttributes | ( | const wxPGAttributeStorage & | attributes | ) |

## ◆ SetAutoUnspecified()

void wxPGProperty::SetAutoUnspecified | ( | bool | enable = `true` | ) |

Set if user can change the property's value to unspecified by modifying the value of the editor control (usually by clearing it).

Currently, this can work with following properties: wxIntProperty, wxUIntProperty, wxFloatProperty, wxEditEnumProperty.

Parameters

  enable | Whether to enable or disable this behaviour (it is disabled by default).

## ◆ SetBackgroundColour()

void wxPGProperty::SetBackgroundColour | ( | const wxColour & | colour,
|  | int | flags = `wxPG_RECURSE`
| ) |  |

Sets property's background colour.

Parameters

  colour | Background colour to use.
  flags | Default is wxPG_RECURSE which causes colour to be set recursively. Omit this flag to only set colour for the property in question and not any of its children.

Remarks
  Unlike wxPropertyGridInterface::SetPropertyBackgroundColour(), this does not automatically update the display.

## ◆ SetCell()

void wxPGProperty::SetCell | ( | int | column,
|  | const wxPGCell & | cell
| ) |  |

Sets cell information for given column.

## ◆ SetChoices()

bool wxPGProperty::SetChoices | ( | wxPGChoices & | choices | ) |

Sets new set of choices for the property.

Remarks
  This operation deselects the property and clears its value.

## ◆ SetChoiceSelection()

void wxPGProperty::SetChoiceSelection | ( | int | newValue | ) |

Sets selected choice and changes property value.

Tries to retain value type, although currently if it is not string, then it is forced to integer.

If newValue is wxNOT_FOUND (`-1`), then the property's value is reset to unspecified, as if SetValueToUnspecified() was called.

## ◆ SetClientData()

void wxPGProperty::SetClientData | ( | void * | clientData | ) |

Sets client data (void*) of a property.

Remarks
  This untyped client data has to be deleted manually.

## ◆ SetClientObject()

void wxPGProperty::SetClientObject | ( | wxClientData * | clientObject | ) |

Sets client object of a property.

## ◆ SetCommonValue()

void wxPGProperty::SetCommonValue | ( | int | commonValue | ) |

Sets common value selected for this property.

-1 for none.

## ◆ SetDefaultColours()

void wxPGProperty::SetDefaultColours | ( | int | flags = `wxPG_RECURSE` | ) |

Sets property's default text and background colours.

Parameters

  flags | Default is wxPG_RECURSE which causes colours to be set recursively. Omit this flag to only set colours for the property in question and not any of its children.

Remarks
  Unlike wxPropertyGridInterface::SetPropertyColoursToDefault(), this does not automatically update the display.

Since
  3.1.0

## ◆ SetDefaultValue()

void wxPGProperty::SetDefaultValue | ( | wxVariant & | value | ) |

Set default value of a property.

Synonymous to

SetAttribute("DefaultValue", value);
wxPGProperty::SetAttribute
void SetAttribute(const wxString &name, wxVariant value)
Sets an attribute for this property.

## ◆ SetEditor() [1/2]

void wxPGProperty::SetEditor | ( | const wxPGEditor * | editor | ) |

Sets editor for a property.

Parameters

  editor | For builtin editors, use wxPGEditor_X, where X is builtin editor's name (TextCtrl, Choice, etc. see wxPGEditor documentation for full list).

For custom editors, use pointer you received from wxPropertyGrid::RegisterEditorClass().

## ◆ SetEditor() [2/2]

void wxPGProperty::SetEditor | ( | const wxString & | editorName | ) |

Sets editor for a property, by editor name.

## ◆ SetExpanded()

void wxPGProperty::SetExpanded | ( | bool | expanded | ) |

## ◆ SetFlagRecursively()

void wxPGProperty::SetFlagRecursively | ( | wxPGPropertyFlags | flag,
|  | bool | set
| ) |  |

Sets or clears given property flag, recursively.

This function is primarily intended for internal use.

See also
  ChangeFlag()

## ◆ SetFlagsFromString()

void wxPGProperty::SetFlagsFromString | ( | const wxString & | str | ) |

Sets flags from a '|' delimited string.

Note that flag names are not prepended with 'wxPG_PROP_'.

## ◆ SetHelpString()

void wxPGProperty::SetHelpString | ( | const wxString & | helpString | ) |

Sets property's help string, which is shown, for example, in wxPropertyGridManager's description text box.

## ◆ SetLabel()

void wxPGProperty::SetLabel | ( | const wxString & | label | ) |

Sets property's label.

Remarks
  - Properties under same parent may have same labels. However, property names must still remain unique.
  - Unlike wxPropertyGridInterface::SetPropertyLabel(), this does not automatically update the display.

## ◆ SetMaxLength()

bool wxPGProperty::SetMaxLength | ( | int | maxLen | ) |

Set maximum length of the text the user can enter in the text editor.

If it is 0, the length is not limited and the text can be as long as it is supported by the underlying native text control widget.

Returns
  Returns true if maximum length was set.

## ◆ SetModifiedStatus()

void wxPGProperty::SetModifiedStatus | ( | bool | modified | ) |

Sets property's "is it modified?" flag.

Affects children recursively.

## ◆ SetName()

void wxPGProperty::SetName | ( | const wxString & | newName | ) |

Sets new (base) name for property.

## ◆ SetParentalType()

void wxPGProperty::SetParentalType | ( | int | flag | ) |

Changes what sort of parent this property is for its children.

Parameters

  flag | Use one of the following values: wxPG_PROP_MISC_PARENT (for generic parents), wxPG_PROP_CATEGORY (for categories), or wxPG_PROP_AGGREGATE (for derived property classes with private children).

Remarks
  You generally do not need to call this function.

## ◆ SetTextColour()

void wxPGProperty::SetTextColour | ( | const wxColour & | colour,
|  | int | flags = `wxPG_RECURSE`
| ) |  |

Sets property's text colour.

Parameters

  colour | Text colour to use.
  flags | Default is wxPG_RECURSE which causes colour to be set recursively. Omit this flag to only set colour for the property in question and not any of its children.

Remarks
  Unlike wxPropertyGridInterface::SetPropertyTextColour(), this does not automatically update the display.

## ◆ SetValidator()

void wxPGProperty::SetValidator | ( | const wxValidator & | validator | ) |

Sets wxValidator for a property.

## ◆ SetValue()

void wxPGProperty::SetValue | ( | wxVariant | value,
|  | wxVariant * | pList = `NULL`,
|  | int | flags = `wxPG_SETVAL_REFRESH_EDITOR`
| ) |  |

Call this to set value of the property.

Unlike methods in wxPropertyGrid, this does not automatically update the display.

Remarks
  Use wxPropertyGrid::ChangePropertyValue() instead if you need to run through validation process and send property change event.

If you need to change property value in event, based on user input, use SetValueInEvent() instead.

Parameters

  value | The value to set.
  pList | Pointer to list variant that contains child values. Used to indicate which children should be marked as modified. Usually you just use NULL.
  flags | wxPG_SETVAL_REFRESH_EDITOR is set by default, to refresh editor and redraw properties.

## ◆ SetValueFromInt()

bool wxPGProperty::SetValueFromInt | ( | long | value,
|  | int | flags = `0`
| ) |  |

Converts integer to a value, and if successful, calls SetValue() on it.

Default behaviour is to do nothing.

Parameters

  value | Int to get the value from.
  flags | If has wxPG_FULL_VALUE, then the value given is an actual value and not an index.

Returns
  true if value was changed.

## ◆ SetValueFromString()

bool wxPGProperty::SetValueFromString | ( | const wxString & | text,
|  | int | flags = `wxPG_PROGRAMMATIC_VALUE`
| ) |  |

Converts string to a value, and if successful, calls SetValue() on it.

Default behaviour is to do nothing.

Parameters

  text | String to get the value from.
  flags | If wxPG_FULL_VALUE is set, the function sets complete, storable value instead of displayable one (they may be different). wxPG_PROGRAMMATIC_VALUE flag is used to indicate that value is being set programmatically (i.e. operation is not caused by user input). If wxPG_REPORT_ERROR is set, a special action should be performed if string couldn't have been successfully converted to the valid value (e.g. a special value can be set in this case).

Returns
  true if value was changed.

## ◆ SetValueImage()

void wxPGProperty::SetValueImage | ( | wxBitmapBundle & | bmp | ) |

Set wxBitmap taken from wxBitmapBundle in front of the value.

This bitmap may be ignored by custom cell renderers.

## ◆ SetValueInEvent()

void wxPGProperty::SetValueInEvent | ( | const wxVariant & | value | ) | const

Call this function in OnEvent(), OnButtonClick() etc.

to change the property value based on user input.

Remarks
  This method is const since it doesn't actually modify value, but posts given variant as pending value, stored in wxPropertyGrid.

## ◆ SetValueToUnspecified()

void wxPGProperty::SetValueToUnspecified | ( |  | ) |

Sets property's value to unspecified (i.e.

Null variant).

## ◆ SetWasModified()

void wxPGProperty::SetWasModified | ( | bool | set = `true` | ) |

Call with false in OnSetValue() to cancel value changes after all (i.e.

cancel true returned by StringToValue() or IntToValue()).

## ◆ StringToValue()

virtual bool wxPGProperty::StringToValue | ( | wxVariant & | variant,
|  | const wxString & | text,
|  | int | argFlags = `0`
| ) |  | const
| virtual

Converts text into wxVariant value appropriate for this property.

Parameters

  variant | On function entry this is the old value (should not be wxNullVariant in normal cases). Translated value must be assigned back to it.
  text | Text to be translated into variant.
  argFlags | If wxPG_FULL_VALUE is set, returns complete, storable value instead of displayable one (they may be different). If wxPG_COMPOSITE_FRAGMENT is set, text is interpreted as a part of composite property string value (as generated by ValueToString() called with this same flag).

Returns
  Returns true if resulting wxVariant value was different.

Remarks
  Default implementation converts semicolon delimited tokens into child values. Only works for properties with children.

You might want to take into account that m_value is Null variant if property value is unspecified (which is usually only case if you explicitly enabled that sort behaviour).

Reimplemented in wxFlagsProperty, wxArrayStringProperty, wxDirProperty, wxLongStringProperty, wxFileProperty, wxEnumProperty, wxBoolProperty, wxFloatProperty, wxUIntProperty, wxIntProperty, wxStringProperty, wxDateProperty, wxMultiChoiceProperty, wxSystemColourProperty, and wxPGRootProperty.

## ◆ UpdateParentValues()

wxPGProperty* wxPGProperty::UpdateParentValues | ( |  | ) |

Updates composed values of parent non-category properties, recursively.

Returns topmost property updated.

Remarks
  Must not call SetValue() (as can be called in it).

## ◆ UsesAutoUnspecified()

bool wxPGProperty::UsesAutoUnspecified | ( |  | ) | const

Returns true if containing grid uses wxPG_EX_AUTO_UNSPECIFIED_VALUES.

## ◆ ValidateValue()

virtual bool wxPGProperty::ValidateValue | ( | wxVariant & | value,
|  | wxPGValidationInfo & | validationInfo
| ) |  | const
| virtual

Implement this function in derived class to check the value.

Return true if it is ok. Returning false prevents property change events from occurring.

Remarks
  - Default implementation always returns true.

Reimplemented in wxEnumProperty, wxFloatProperty, wxUIntProperty, and wxIntProperty.

## ◆ ValueToString()

virtual wxString wxPGProperty::ValueToString | ( | wxVariant & | value,
|  | int | argFlags = `0`
| ) |  | const
| virtual

Converts property value into a text representation.

Parameters

  value | Value to be converted.
  argFlags | If 0 (default value), then displayed string is returned. If wxPG_FULL_VALUE is set, returns complete, storable string value instead of displayable. If wxPG_EDITABLE_VALUE is set, returns string value that must be editable in textctrl. If wxPG_COMPOSITE_FRAGMENT is set, returns text that is appropriate to display as a part of string property's composite text representation.

Remarks
  Default implementation calls GenerateComposedValue().

Reimplemented in wxArrayStringProperty, wxDirProperty, wxLongStringProperty, wxFileProperty, wxFlagsProperty, wxEnumProperty, wxBoolProperty, wxFloatProperty, wxUIntProperty, wxIntProperty, wxStringProperty, wxDateProperty, wxMultiChoiceProperty, wxColourProperty, wxSystemColourProperty, wxFontProperty, and wxPropertyCategory.

## Member Data Documentation

## ◆ m_clientData

void* wxPGProperty::m_clientData

This member is public so scripting language bindings wrapper code can access it freely.